SystemOrganization addCategory: #'Facebook-Core'!
SystemOrganization addCategory: #'Facebook-Graph'!
SystemOrganization addCategory: #'Facebook-Test'!

WAComponent subclass: #FBComponent
	instanceVariableNames: 'request'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Facebook-Test'!

!FBComponent class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 8/7/2011 13:41'!
canBeRoot
	^true! !

!FBComponent class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 7/28/2011 17:04'!
request: aSignedRequest
	^self basicNew
		initializeWithRequest: aSignedRequest;
		yourself! !

!FBComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 8/7/2011 14:11'!
renderContentOn:  html
	| me |
	me := self session user.
	html heading: 'Hello, World'.
	html heading: 'About Me'.
	html image src: me pictureUrl.
	html definitionList:  [
		html
			definitionTerm:  'Name';
			definitionData: me name] ! !

WASession subclass: #FBSession
	instanceVariableNames: 'user graphApi'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Facebook-Core'!

!FBSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 8/7/2011 14:07'!
authorize
	self requestContext respond: [ :resp |
		resp
			contentType: WAMimeType textHtml;
			nextPutAll: (WAHtmlCanvas builder
				fullDocument: true;
				rootBlock: [ :root | 
					root title: 'Seaside'; beXhtml10Strict.
					root htmlAttributes at: 'xmlns' put: 'http://www.w3.org/1999/xhtml' ];
				render: [ :html | 	html script:  ('top.location.href=''{1}''' format: {self application authorizeUrl}) ]) ]! !

!FBSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 8/7/2011 14:13'!
graphApi
	^graphApi! !

!FBSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 8/7/2011 14:14'!
graphApi: anApi
	graphApi := anApi! !

!FBSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 8/7/2011 14:23'!
initializeFacebookDetails
	| signedRequest |
	signedRequest := FBSignedRequest decodeRequest: (self requestContext request fields at: 'signed_request').
	signedRequest isAuthorized 
		ifTrue: [ self graphApi:  (FBGraphAPI accessToken:  signedRequest oauthToken ).
			self user: self graphApi currentUser ]
		ifFalse: [ self authorize ]! !

!FBSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 8/7/2011 14:19'!
start
	self initializeFacebookDetails.
	super start! !

!FBSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 8/7/2011 13:41'!
user
	^user! !

!FBSession methodsFor: 'as yet unclassified' stamp: 'StuartHerring 8/7/2011 14:13'!
user: aUser
	user := aUser! !

TestCase subclass: #TestFBObject
	instanceVariableNames: 'id name object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Facebook-Test'!

!TestFBObject methodsFor: 'as yet unclassified' stamp: 'StuartHerring 7/30/2011 15:30'!
setUp
	id := '1234'.
	name := 'TestName'.
	object := FBGraphObject fromJsonString:  '{"id": "', id, '", "name" : "', name, '"}'! !

!TestFBObject methodsFor: 'as yet unclassified' stamp: 'StuartHerring 7/30/2011 15:29'!
testId
	self assert: id equals: object id! !

!TestFBObject methodsFor: 'as yet unclassified' stamp: 'StuartHerring 7/30/2011 15:28'!
testName
	self assert: name equals: object name! !

!TestFBObject methodsFor: 'as yet unclassified' stamp: 'StuartHerring 7/30/2011 16:15'!
testPictureUrl
	[ :api | object setApi: api.
		[ object pictureUrl ] should strictly satisfy: [ api pictureUrlFor: object id ]]
	runScenario ! !

TestCase subclass: #TestFBSignedRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Facebook-Test'!

!TestFBSignedRequest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 7/29/2011 11:15'!
testExpires
	| r d |
	r := FBSignedRequest fromJsonString:  '{"expires": "1311893567"}'.
	d := DateAndTime year: 2011 month: 7 day: 28 hour: 22 minute: 52 second: 47.
	self assert: d equals: r expires! !

!TestFBSignedRequest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 7/29/2011 10:58'!
testIssuedAt
	| r d |
	r := FBSignedRequest fromJsonString:  '{"issued_at": "1311893567"}'.
	d := DateAndTime year: 2011 month: 7 day: 28 hour: 22 minute: 52 second: 47.
	self assert: d equals: r issuedAt! !

!TestFBSignedRequest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 7/29/2011 10:49'!
testNoUserIdMeansNotAuthorized
	| r |
	r := FBSignedRequest fromJsonString:  '{}'.
	self deny: r isAuthorized.	! !

!TestFBSignedRequest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 7/29/2011 11:17'!
testOAuthToken
	| r |
	r := FBSignedRequest fromJsonString:  '{"oauth_token": "12345"}'.
	self assert: '12345' equals: r oauthToken! !

!TestFBSignedRequest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 7/29/2011 10:50'!
testUserIdMeansAuthorized
	| r |
	r := FBSignedRequest fromJsonString:  '{"user_id": "1234"}'.
	self assert: r isAuthorized.	! !

WAApplication subclass: #FBApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Facebook-Core'!

!FBApplication class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 8/7/2011 12:49'!
description
	^'Facebook Application'! !

!FBApplication methodsFor: 'as yet unclassified' stamp: 'StuartHerring 8/7/2011 10:19'!
appId
	^self preferenceAt: #applicationId! !

!FBApplication methodsFor: 'as yet unclassified' stamp: 'StuartHerring 8/7/2011 14:29'!
authorizeUrl
	^'https://www.facebook.com/dialog/oauth?client_id={1}&redirect_uri={2}' 
		format: {self appId. self canvasPage}! !

!FBApplication methodsFor: 'as yet unclassified' stamp: 'StuartHerring 8/7/2011 14:28'!
canvasPage
	^self preferenceAt: #canvasPage! !

!FBApplication methodsFor: 'as yet unclassified' stamp: 'StuartHerring 8/7/2011 13:01'!
defaultConfiguration
	^super defaultConfiguration
		addParent: FBConfiguration instance;
		yourself! !

!FBApplication methodsFor: 'as yet unclassified' stamp: 'StuartHerring 8/7/2011 13:45'!
initialize
	super initialize.
	self preferenceAt: #sessionClass put: FBSession! !

WASystemConfiguration subclass: #FBConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Facebook-Core'!

!FBConfiguration methodsFor: 'as yet unclassified' stamp: 'StuartHerring 8/7/2011 13:51'!
describeOn:  config
	(config string: #applicationId)
		group: #facebook;
		comment: 'Facebook Application ID'.
		
	(config string: #secret)
		group: #facebook;
		comment: 'Application Secret'.
		
	(config url: #canvasPage)
		group: #facebook;
		comment: 'Canvas Page Url'! !

Object subclass: #FBGraphAPI
	instanceVariableNames: 'token httpClient'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Facebook-Graph'!

!FBGraphAPI class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 7/29/2011 16:20'!
accessToken: aToken
	^self basicNew
		initializeWithAccessToken: aToken;
		yourself! !

!FBGraphAPI class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 7/30/2011 17:06'!
graphUrl 
	^WAUrl absolute: 'https://graph.facebook.com'! !

!FBGraphAPI class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 7/30/2011 17:07'!
new
	^self basicNew
		initializeWithAccessToken:  nil;
		yourself. ! !

!FBGraphAPI methodsFor: 'as yet unclassified' stamp: 'StuartHerring 7/30/2011 17:20'!
currentUser
	^self get: 'me'! !

!FBGraphAPI methodsFor: 'as yet unclassified' stamp: 'StuartHerring 7/30/2011 17:15'!
get: id
	| response |
	response := httpClient httpGet: (self urlFor: id).
	response statusCode = 200 
		ifTrue: [ ^(FBGraphObject  fromJsonString:  response  bodyContents) setApi: self; yourself ]
		ifFalse: [self handleErrorResponse: response]! !

!FBGraphAPI methodsFor: 'as yet unclassified' stamp: 'StuartHerring 7/30/2011 17:12'!
handleErrorResponse:  response
	| error |
	error := (JSJsonParser parse: response bodyContents) at: #error.
	Error signal: ('{1}: {2}' format: {(error at: #type). (error at: #message)})! !

!FBGraphAPI methodsFor: 'as yet unclassified' stamp: 'StuartHerring 7/30/2011 16:37'!
initializeWithAccessToken:  aToken
	self initialize.
	token := aToken.
	httpClient := CFServicePharoUtils default httpClient.! !

!FBGraphAPI methodsFor: 'as yet unclassified' stamp: 'StuartHerring 7/30/2011 17:17'!
pictureUrlFor: id
	| url |
	url := self class graphUrl
		addToPath: id;
		addToPath: #picture;
		yourself.
	token ifNotNil: [url addField: 'access_token' value: token].
	^url asString.! !

!FBGraphAPI methodsFor: 'as yet unclassified' stamp: 'StuartHerring 7/30/2011 17:14'!
urlFor: id
	| url |
	url := self class graphUrl
		addToPath: id;
		yourself.
	token ifNotNil: [url addField: 'access_token' value: token].
	^url asString.! !

Object subclass: #FBGraphObject
	instanceVariableNames: 'id name api pictureUrl'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Facebook-Graph'!

!FBGraphObject class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 7/30/2011 15:27'!
fromJsonString: aJsonString
	^self basicNew
		initializeWithDictionary:  (JSJsonParser parse: aJsonString);
		yourself ! !

!FBGraphObject methodsFor: 'as yet unclassified' stamp: 'StuartHerring 7/30/2011 15:30'!
id
	^id! !

!FBGraphObject methodsFor: 'as yet unclassified' stamp: 'StuartHerring 7/30/2011 15:29'!
initializeWithDictionary:  aDictionary
	self initialize.
	id := aDictionary at: #id.
	name := aDictionary at: #name.! !

!FBGraphObject methodsFor: 'as yet unclassified' stamp: 'StuartHerring 7/30/2011 15:30'!
name
	^name! !

!FBGraphObject methodsFor: 'as yet unclassified' stamp: 'StuartHerring 7/30/2011 16:16'!
pictureUrl
	^api pictureUrlFor: id ! !

!FBGraphObject methodsFor: 'as yet unclassified' stamp: 'StuartHerring 7/30/2011 16:15'!
setApi: graphApiInstance
	api := graphApiInstance! !

FBGraphObject subclass: #FBGraphUser
	instanceVariableNames: 'firstName lastName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Facebook-Graph'!

!FBGraphUser methodsFor: 'as yet unclassified' stamp: 'StuartHerring 8/6/2011 21:08'!
initializeWithDictionary:  aDictionary
	super initializeWithDictionary:  aDictionary.
	firstName := aDictionary  at: 'first_name'.
	lastName := aDictionary at: 'last_name'.
	! !

Object subclass: #FBSignedRequest
	instanceVariableNames: 'userId issuedAt expires token'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Facebook-Core'!

!FBSignedRequest class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 8/6/2011 21:57'!
decodeRequest: aRequestString
	| r |
	aRequestString ifNil: [^nil].
	r := aRequestString splitOn: #..
	self validateSignature: (r at: 1).
	^FBSignedRequest fromJsonString:
		((r at: 2) collect: [ :c | c = $- ifTrue: [ $+] ifFalse: [ c = $_ ifTrue: [$/] ifFalse: [c] ]]) base64Decoded! !

!FBSignedRequest class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 7/28/2011 16:49'!
fromJsonString:  jsonString 
	^self basicNew
		initializeWithDictionary: (JSJsonParser parse: jsonString);
		yourself.! !

!FBSignedRequest class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 8/6/2011 21:57'!
validateSignature: aByteString 
! !

!FBSignedRequest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 7/29/2011 10:38'!
expires
	^expires! !

!FBSignedRequest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 7/29/2011 11:17'!
initializeWithDictionary:  aDictionary
	self initialize.
	aDictionary at: 'user_id' ifPresent: [ :u | userId := u ].
	aDictionary at: 'issued_at' ifPresent: [ :d | issuedAt := DateAndTime fromUnixTime: d].
	aDictionary at: 'expires' ifPresent: [ :d | expires := DateAndTime fromUnixTime: d].
	aDictionary at: 'oauth_token' ifPresent: [ :t | token := t ]! !

!FBSignedRequest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 7/28/2011 11:48'!
isAuthorized
	^userId notNil! !

!FBSignedRequest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 7/29/2011 10:38'!
issuedAt
	^issuedAt! !

!FBSignedRequest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 7/29/2011 10:38'!
oauthToken
	^token! !

!FBSignedRequest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 7/28/2011 17:06'!
userId
	^userId! !
